import java.io.*;
import java.util.*;


public class Graphe {
	Vector<Lien> donnees = new Vector<Lien>();
	
	public Graphe(String nomdufichier) throws IOException {
		litFichier(new File(nomdufichier));
	}
	
	/**
	* calcule la matrice (vous devez la normaliser
	* pour obtenir la matrice de transition).
	*/
	public boolean[][] calculeMatrice() {
		int compteur = 0;
		Hashtable<String,Integer> index = new Hashtable<String,Integer>();
		for (Lien k: donnees) {
			if(index.get(k.mDebut) == null) 
			  index.put(k.mDebut,new Integer(compteur++));
			if(index.get(k.mFin) == null) 
			  index.put(k.mFin,new Integer(compteur++));
		}
		boolean[][] mat = new boolean[compteur][compteur];
		for (Lien e: donnees) {
			String key = e.mDebut;
			int ikey = index.get(key).intValue();
			String val = e.mFin;
			int ival = index.get(val).intValue();
			mat[ikey][ival] = true;
		}
		return mat;
	}
	
	/**
	* donne la liste des noeuds du graphe
	*/
	public Vector<String> noeuds() {
		Vector<String> n = new Vector<String>();
		HashSet<String> index = new HashSet<String>();
		for (Lien k: donnees) {
			if(!index.contains(k.mDebut)) {
			  index.add(k.mDebut);
			  n.add(k.mDebut);
			}
			if(!index.contains(k.mFin)) { 
			  index.add(k.mFin);
			  n.add(k.mFin);
			}
		}
		return n;
	}
	
	private void litFichier(File fichier) throws IOException {
		BufferedReader br = new BufferedReader(new FileReader(fichier));
		try {
		  String line;
		  while((line = br.readLine())!= null) {
			String[] vals = line.split("->");
			if(vals.length != 2) continue;
			donnees.add(new Lien(vals[0].trim(),vals[1].trim()));
			System.out.println(vals[0].trim()+"->" +vals[1].trim());
		  }
		} finally {
			br.close();
		}
	}
	
	public static void main(String[] args) throws IOException {
		Graphe g = new Graphe(args[0]);
		Vector<String> n = g.noeuds();
		for(String s : n)
		  System.out.println(s);
		boolean[][] m = g.calculeMatrice();
		for(int k = 0; k < m.length; ++k) {
		  for(int l = 0; l < m.length; ++l)
		    System.out.print((m[k][l] ? 1 : 0)+" ");
		  System.out.println();
		}
	}
	
}


class Lien {
	String mDebut, mFin;
	public Lien(String debut, String fin) {
		mDebut = debut;
		mFin = fin;
	}
}